<?php
/*
 * Class qui gère la sécurité des données qui transit
 * C'est plus des outils qu'un objet.
 */

class Secure{

    function __construct()
    {
        /* */
    }
    

    public function safest($var, $charset='UTF-8')
    {
        $var = htmlentities($var, ENT_QUOTES, $charset);
        return $var;
    }

  
    static function smartQuote($value)
    {
        if ((!isset($value)) || (is_null($value)) || ($value === ""))
        {
            $value = '';
        }
        else
        {
            if (is_string($value))
                $value = mysql_real_escape_string($value);
            else
                $value = (is_numeric($value)) ? ($value) : ("'ERROR: unhandled datatype in quote_smart'");
        }

        return $value;
    }


    public function remove_accents($str, $charset='utf-8')
    {
        $str = htmlentities($str, ENT_NOQUOTES, $charset);

        $str = preg_replace('#\&([A-za-z])(?:acute|cedil|circ|grave|ring|tilde|uml)\;#', '\1', $str);
        $str = preg_replace('#\&([A-za-z]{2})(?:lig)\;#', '\1', $str); // pour les ligatures e.g. '&oelig;'
        $str = preg_replace('#\&[^;]+\;#', '', $str); // supprime les autres caractères

        return $str;
    }


    public function safeFileName($var, $delete_dot=false)
    {
        $var = Secure::remove_accents($var);
        $var = strtolower($var);
        $var = str_replace("'","-",$var);
        $var = str_replace("\"","-",$var);
        $var = str_replace(" ","-",$var);
        $var = str_replace("---","-",$var);
        $var = str_replace("--","-",$var);
        $var = str_replace("--","-",$var);

        if(!$delete_dot)
            $var = eregi_replace("[^a-z0-9\_\.-]","",$var);
        else
            $var = eregi_replace("[^a-z0-9\-_]","",$var);

        $var = rtrim($var,'-');
        $var = ltrim($var,'-');

        return $var;
    }

    public function safeUrlName($var)
    {
        $var = Secure::remove_accents($var);
        $var = strtolower($var);
        $var = str_replace("_","-",$var);
        $var = str_replace("/","-",$var);
        $var = str_replace("'","-",$var);
        $var = str_replace("\"","-",$var);
        $var = str_replace(" ","-",$var);
        $var = str_replace("---","-",$var);
        $var = str_replace("--","-",$var);
        $var = str_replace("--","-",$var);
        $var = str_replace("--","-",$var);

        $var = eregi_replace("[^a-z0-9\_\.-]","",$var);

        $var = rtrim($var,'-');
        $var = ltrim($var,'-');

        return $var;
    }

    public function safeForRSS($var)
    {
        $var = htmlentities($var, ENT_NOQUOTES, 'utf-8');
        $var = preg_replace('#\&([A-za-z])(?:uml|circ|tilde|acute|grave|cedil|ring)\;#', '\1', $var);
        $var = preg_replace('#\&([A-za-z]{2})(?:lig)\;#', '\1', $var);
        $var = preg_replace('#\&[^;]+\;#','', $var);

        return $var;
    }


    /*
     * On secure tous les valeur passé en POST
     * Les clef ne sont pas touché
     */
    public function secure_posts()
    {
        if($_POST)
        {
            foreach($_POST as $k => $d)
            {
                $_POST[$k] = Secure::safest($d);
            }
        }
    }
    
}