<?php
/* !! Pré-Requis : Le fichier config.php doit être correctement renseigné !!
 *
 * > Test si la connexion MySQL se fait bien.
 * > Demander un mot de passe pour le compte admin
 * > Création des tables MySQL
 * > Générer un grain de sel
 * > Enregistrer le tout
 */

define('INWWW', 1);

include('./includes/config.php');
include('./includes/functions.php');

include('./includes/classes/Secure.class.php');


// Connexion MySQL
if(!mysql_connect($CFG['bdd']['host'],$CFG['bdd']['username'],$CFG['bdd']['password']))
    exit('Erreur de connexion à la base de donnée.');

if(!mysql_select_db($CFG['bdd']['schema']))
    exit('Erreur sur la base de donnée [No Selection].');

mysql_query("SET NAMES ".$CFG['encoding']);
mysql_set_charset($CFG['encoding']);
// --


// déjà installé ?
if(mysql_table_exists(DB_FILE_TABLE, $CFG['bdd']['schema']) || mysql_table_exists(DB_CFG_TABLE, $CFG['bdd']['schema']))
    exit('INSTALLATION IMPOSSIBLE :: Vous avez déjà installé MyPHPUpload.');




// Test de CHMOD sur le répertoire d'upload et le répertoire de cache
$liste_a_tester = array(
                        $CFG['upload_dir'],
                        $CFG['upload_cache_dir']
                      );
clearstatcache();

$perms_Errors = '';
foreach($liste_a_tester as $key=>$valeur)
{
    $lemod = @chmodnum(getperms($valeur));

    if(!is_writable($valeur))
        $perms_Errors .= '<p>'.$valeur.' <span style="color:red"><u>n\'est PAS</u> accessible en &eacute;criture.</span> Valeur CHMOD actuel : <span style="color:red">'.$lemod.'</span></p>';
}

if(!empty($perms_Errors))
{
    echo '
    <h1>Installation</h1>
    <h2>Infos de connexion administrateur</h2>'.$perms_Errors;

    echo '<p><b>Pour continuer, vous devez absolument rendre les deux répertoires accessibles en lecture et en écriture (CHMOD 0777).</b></p>';

    exit();
}


// On demande le mot de passe
if(!$_POST)
{
    $uri_base = str_replace('install.php', '', $_SERVER['PHP_SELF']);
    $domain = $_SERVER['HTTP_HOST'];

    echo '
    <h1>Installation</h1>
    <p>Merci de mettre un login et un mot de passe et de vérifier que les autres informations sont correct.</p>

    <form name="form" method="post" action="">
        <table width="100%">
            <tr>
                <td colspan="2" style="margin-top:10px; margin-bottom:5px"><h3>Infos de connexion</h3></td>
            <tr>
            <tr>
                <td width="130">Login</td>
                <td><input name="login" type="text" id="login" /></td>
            </tr>
            <tr>
                <td>Mot de passe</td>
                <td><input name="password" type="text" id="password" /></td>
            </tr>
            <tr>
                <td colspan="2"><h3 style="margin-top:10px; margin-bottom:5px">Divers</h3></td>
            <tr>
            <tr>
                <td>URI de base</td>
                <td><input name="uri_base" type="text" id="uri_base" value="'.Secure::safest($uri_base).'" style="width:300px" /> (URI absolue HTTP)</td>
            </tr>
            <tr>
                <td>Domaine</td>
                <td><input name="domain" type="text" id="domain" value="'.Secure::safest($domain).'" style="width:250px" /> (Domaine ou sous-domaine, sans http://)</td>
            </tr>
            <tr>
                <td colspan="2"><input type="submit" name="Submit" value="Valider et terminer l\'installation >" /></td>
            </tr>
        </table>
    </form>';
}
else
{

    if(empty($_POST['password']) || strlen($_POST['password']) < 4)
        exit('Le mot de passe est vide OU fais moins de 4 caractères. Merci de cliquer sur Retour.');

    if(empty($_POST['login']))
        exit('Le login est vide. Merci de cliquer sur Retour.');

    if(empty($_POST['uri_base']))
        exit('URI de base ne peux pas être vide.');

    if(empty($_POST['domain']))
        exit('Le domaine ne peux pas être vide.');
    
    // le grain de sel pour sécurisé les mots de passe
    $salt = uniqid( rand(1,9) , 3);

    // encodage du mot de passe
    $password = md5($_POST['password'] . $salt);
    $login = Secure::smartQuote($_POST['login']);
    
    $domain = Secure::smartQuote($_POST['domain']);
    $uri_base = Secure::smartQuote($_POST['uri_base']);


    // Création des tables MySQL
    $data_Sql = array();

    $data_Sql[] = '
    CREATE TABLE IF NOT EXISTS `'.DB_FILE_TABLE.'` (
      `id` int(8) NOT NULL auto_increment,
      `date` int(10) NOT NULL,
      `reference` varchar(38) NOT NULL default \'\',
      `file_name` varchar(50) NOT NULL default \'\',
      `file_real_name` varchar(200) NOT NULL,
      `ip` varchar(15) NOT NULL default \'\',
      `nbr_view` mediumint(7) NOT NULL default \'0\',
      `nbr_dl` mediumint(7) NOT NULL default \'0\',
      PRIMARY KEY  (`id`),
      KEY `reference` (`reference`)
    ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;';

    $data_Sql[] = '
    CREATE TABLE IF NOT EXISTS `'.DB_CFG_TABLE.'` (
      `clef` varchar(30) NOT NULL,
      `valeur` varchar(50) NOT NULL,
      `infos` varchar(100) NOT NULL,
      `name` varchar(50) NOT NULL,
      KEY `key` (`clef`)
    ) ENGINE=MyISAM DEFAULT CHARSET=utf8;';

    // Config ADMIN
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='admin_login', valeur='$login'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='admin_password', valeur='$password'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='salt', valeur='$salt'";

    // Config Globale par défault
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='klite', valeur='90', infos='Chiffre de 1 à 100', name='Qualité des images'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='t_width', valeur='250', infos='Chiffre de 1 à 1024', name='Largeur miniature'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='file_size_max', valeur='0', infos='Poids exprimé en octet', name='Poid fichier maximal'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='date_peremption', valeur='0', infos='Nombre de secondes (0 à ...)', name='Date de péremption'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='rewrite', valeur='0', infos='0 (non) ou 1 (oui)', name='Re-écriture d\'URL'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='invalide_exts', valeur='php,exe,sh,html,htm', infos='Liste d\'extensions séparées par une virgule', name='Extensions interdites'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='valide_exts', valeur='', infos='Liste d\'extensions séparées par une virgule', name='Extensions autorisés'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='email_expediteur', valeur='', infos='Renseigner l\'adresse email qui sera l\'expéditeur', name='Email expéditeur'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='uri_base', valeur='$uri_base', infos='URI HTTP de base absolue', name='URI de Base'";
    $data_Sql[] = "INSERT INTO `".DB_CFG_TABLE."` SET clef='domain', valeur='$domain', infos='Domaine ou sous-domaine, sans http://', name='Domaine'";


    // Exec des SQL
    foreach($data_Sql as $n => $requete)
    {
        if(!mysql_query($requete))
            exit('Erreur lors de la création des tables MySQL : '.mysql_error());
    }


    // Les tables sont ajouté à la BDD :: Cool !


    // On affiche le message comme quoi tout va bien
    echo '
    <h1>Installation</h1>
    <h2>SUCCES</h2>
    <p>L\'installation est terminée.</p>
    <p>
        Login : admin<br />
        Mot de passe : '.Secure::safest($_POST['password']).'
    </p>
    <p><a href="./?m=admin">Accès à l\'administration</a></p>
    <p><a href="./?m=files">Accès à MyPHPUpload</a></p>
    ';
}











function chmodnum($mode)
{
    $mode=substr($mode,-9);// on prend les 9 derniers, marche avec fichiers ou dossiers
    $mode = str_pad($mode,9,'-');
    $trans = array('-'=>'0','r'=>'4','w'=>'2','x'=>'1');
    $mode = strtr($mode,$trans);

    $newmode = '';
    $newmode .= $mode[0]+$mode[1]+$mode[2];
    $newmode .= $mode[3]+$mode[4]+$mode[5];
    $newmode .= $mode[6]+$mode[7]+$mode[8];
    return $newmode;
}

function getperms($file)
{
    if(@function_exists(fileperms))
    {

        $perms = fileperms($file);
        if (($perms & 0xC000) == 0xC000) {
            // Socket
            $info = 's';
        } elseif (($perms & 0xA000) == 0xA000) {
            // Lien symbolique
            $info = 'l';
        } elseif (($perms & 0x8000) == 0x8000) {
            // Régulier
            $info = '';
        } elseif (($perms & 0x6000) == 0x6000) {
            // Block spécial
            $info = 'b';
        } elseif (($perms & 0x4000) == 0x4000) {
            // Dossier
            $info = 'd';
        } elseif (($perms & 0x2000) == 0x2000) {
            // Caract�re sp�cial
            $info = 'c';
        } elseif (($perms & 0x1000) == 0x1000) {
            // FIFO pipe
            $info = 'p';
        } else {
            // Inconnu
            $info = 'u';
        }

        // Propriétaire
        $info .= (($perms & 0x0100) ? 'r' : '-');
        $info .= (($perms & 0x0080) ? 'w' : '-');
        $info .= (($perms & 0x0040) ?
        (($perms & 0x0800) ? 's' : 'x' ) :
        (($perms & 0x0800) ? 'S' : '-'));

        // Groupe
        $info .= (($perms & 0x0020) ? 'r' : '-');
        $info .= (($perms & 0x0010) ? 'w' : '-');
        $info .= (($perms & 0x0008) ?
        (($perms & 0x0400) ? 's' : 'x' ) :
        (($perms & 0x0400) ? 'S' : '-'));

        // Tous
        $info .= (($perms & 0x0004) ? 'r' : '-');
        $info .= (($perms & 0x0002) ? 'w' : '-');
        $info .= (($perms & 0x0001) ?
        (($perms & 0x0200) ? 't' : 'x' ) :
        (($perms & 0x0200) ? 'T' : '-'));

        return $info;

    }

    $errorfunction = '<b>Indeterminé</b>, fonction php fileperms() absent';

    return $errorfunction;
}